/*
  Ejemplo de uso de arrays
  Created by Miguel Angel Rubio - marubio@ugr.es
  date: June 2014

  Mirar el documento de instrucciones
  This example code is in the public domain.
 */

#include <PhysicalComputingDemonstrations.h>
#include "tonos.h"

void setup() {                
  
  // notas melodia:
  int melodia[] = {
  NOTA_SI_3, NOTA_SI_3, NOTA_SI_3, NOTA_SOL_3, NOTA_RE_4, NOTA_SI_3, NOTA_SOL_3, NOTA_RE_4, NOTA_SI_3, NOTA_FA_SOST_4, 
  NOTA_FA_SOST_4, NOTA_FA_SOST_4, NOTA_SOL_4, NOTA_RE_4, NOTA_SI_3, NOTA_SOL_3, NOTA_RE_4, NOTA_SI_3};

  //
  int tempo = 2000;
  int pin_altavoz = 3;
  int redonda = tempo;
  int blanca = tempo/2;
  int negra = tempo/4;
  int corchea = tempo/8;

  // duracion de la melodia:
  int duracion_nota[] = {negra, negra, negra, negra, corchea, negra, negra, 
     corchea, blanca, negra, negra, negra, negra, corchea, negra,  negra, corchea, blanca};
  

  //Tocamos una nota
  tocar (pin_altavoz, NOTA_SI_3, blanca);

  // Toca varias notas
  tocar (pin_altavoz, melodia, duracion_nota, 18);

}

void loop() {
}


//Toca una nota
void tocar (int pin_altavoz, int nota, int duracion) { 

    tone(pin_altavoz, nota,duracion);
    delay(duracion*1.3);
    noTone(pin_altavoz);
}

//Toca varias notas
void tocar (int pin_altavoz, int* melodia, int* duracion, int long_cancion) { 

  // vamos nota a nots
  for (int pos = 0; pos < long_cancion; pos++) {

    tone(pin_altavoz, melodia[pos],duracion[pos]);

    // Incluimos una pausa para separar las notas
    int pausa = duracion[pos] * 1.2;
    delay(pausa);
    
    // Paramos el altavoz
    noTone(pin_altavoz);
  }            
}

