/*
  Ejemplo de uso de entradas y salidas
  Created by Miguel Angel Rubio - marubio@ugr.es
  date: June 2014
  Mirar el documento de instrucciones
  This example code is in the public domain.
 */

#include <PhysicalComputingDemonstrations.h>

void setup() {                

Serial.begin(9600);

escribe(16);

}



void loop() {
  int temper = lee_temp_salida();
  Serial.println(temper);
  para(1);
}


//Función lee_temp. Lee la temperatura mediante Arduino
//El sensor es el TMP36 del Arduino Starter Kit
//Salida: la temperatura
int lee_temp_salida(){
 
 char str[256];
 //El pin que vamos a usar para leer la temperatura
 int analog_pin = 0;

 //Realizamos 20 medidas para minimizar el error.
 float temp = 0;
 int num_medidas = 20;
 float voltaje;
 
 for (int cont = 0; cont < 20; cont++) {
    voltaje = lee_voltaje(analog_pin); //Medida directa
    voltaje = voltaje*5/1024; //Voltaje normalizado
    temp= temp+voltaje/0.01 - 50; //En ºC
 }

 //Hacemos la media y lo devolvemos
 int temperatura = temp/num_medidas;
 return temperatura;
 
}


//Función lee_temp. Lee la temperatura mediante Arduino
//El sensor es el TMP36 del Arduino Starter Kit
//Ver los pdf adjuntos
void lee_temp(){
 
 char str[256];
 //El pin que vamos a usar para leer la temperatura
 int analog_pin = 0;

 //Realizamos 20 medidas para minimizar el error.
 float temp = 0;
 int num_medidas = 20;
 float voltaje;
 
 for (int cont = 0; cont < 20; cont++) {
    voltaje = lee_voltaje(analog_pin); //Medida directa
    voltaje = voltaje*5/1024; //Voltaje normalizado
    temp= temp+voltaje/0.01 - 50; //En ºC
 }

 //Hacemos la media y lo mostramos
 int temperatura = temp/num_medidas;
 sprintf(str, "La temperatura es    %d C",temperatura);
 Serial.println(str);
 
}


//Saca por led el número que introduzcamos en binario
//Máximo número 31
//Se utilizan los pines del 13 al 9
//13 menos significativo
//9 más significativo
//Para poder hacer el juego de adivinar el método es necesario
//que los leds tengan distintos colores.
//Argumento de entrada
//num: el número que vamos a pasar a binario

void escribe (int num) {

//Los leds con los que voy a trabajar
int rango_led [5]= {9,10,11,12,13};
int val;

for (int cont = 0; cont < 5; cont++){
    val = num%2; //Calculo el resto de dividir por dos
    num = num/2; //Calculo el cociente y lo asigno a num
    
    //Si la cifra en binario vale 1
    if (val == 1)
        enciende_led(rango_led[cont]); //enciendo el led
    //Si no
    else 
        apaga_led(rango_led[cont]); //apago el led
}

}
