/*
  Ejemplos avanzados de uso de bucles 
  Created by Miguel Angel Rubio - marubio@ugr.es
  date: June 2014
  Mirar el documento de instrucciones
  This example code is in the public domain.
 */

#include <PhysicalComputingDemonstrations.h>
#include <Servo.h>

void setup() {                
  
//Cual es el nombre del Servo Motor
int pin_servo = 7;
Servo mi_servo;
mi_servo.attach(pin_servo);

//Cual es el nombre de los leds
int pin_rojo = 12;
int pin_naranja = 13;

////enciendo los leds
//enciende_led(pin_rojo);
//enciende_led(pin_naranja);

  
////Repito los giros tres veces
//for (int cont = 1; cont <= 3; cont++){
//    //Giro en un sentido
//    for (int angulo=0; angulo <= 180; angulo = angulo +5){
//        mover_servo(mi_servo,angulo);
//        para(.1);
//    }
//    
//    //Giro en el otro sentido
//    for (int angulo=180; angulo <= 0; angulo = angulo - 5){
//        mover_servo(mi_servo,angulo);
//        para(.1);
//    }
//}


////Versión con destellos

////enciendo los leds
//enciende_led(pin_rojo);
//enciende_led(pin_naranja);


////Repito los giros tres veces
//for (int cont = 1; cont <= 3; cont++){
//  
//    //Cambio el destello
//    enciende_led(pin_rojo);
//    apaga_led(pin_naranja);
//    
//    
//    //Giro en un sentido
//    for (int angulo=0; angulo <= 180; angulo = angulo +5){
//        mover_servo(mi_servo,angulo);
//        
//        if (angulo > 90){
//          //Cambiar destello...
//          apaga_led(pin_rojo);
//          enciende_led(pin_naranja);
//        }
//        para(.1);
//    }
//    
//    //Giro en el otro sentido
//    for (int angulo=180; angulo <= 0; angulo = angulo - 5){
//        mover_servo(mi_servo,angulo);
//        if (angulo > 90){
//          //Cambiar destello...
//          apaga_led(pin_rojo);
//          enciende_led(pin_naranja);
//        }
//        para(.1);
//    }
//}


Serial.begin(9600);


//veo la distancia
float distancia = lee_distancia();

//Vigilando...
while (distancia > 30){
    Serial.println(distancia);
    //veo la distancia
    distancia = lee_distancia();
    para(.5);
}


//enciendo los leds
enciende_led(pin_rojo);
enciende_led(pin_naranja);

//Repito los giros tres veces
for (int cont = 1; cont <= 3; cont++){
    //Giro en un sentido
    for (int angulo=0; angulo <= 180; angulo = angulo +5){
        mover_servo(mi_servo,angulo);
        para(.1);
    }
    
    //Giro en el otro sentido
    for (int angulo=180; angulo <= 0; angulo = angulo - 5){
        mover_servo(mi_servo,angulo);
        para(.1);
    }
}

apaga_led(pin_rojo);
apaga_led(pin_naranja);
mover_servo(mi_servo,90);
}



void loop() {
}


//Función lee_distancia. Lee la distancia mediante Arduino
//El sensor es el LV-MaxSonar EZ1 


float lee_distancia(){

 //El pin que vamos a usar para leer la distancia
 int analog_pin = 3;
 //Numero de medidas
 int num_medidas = 15;

 //Realizamos num_medidas medidas para estabilizar el resultado
 //Las medidas del sensor no son muy estables
 float distancia_inst = 0;
 float voltaje;

 
 for (int cont = 0; cont < num_medidas; cont++){
    voltaje = lee_voltaje(analog_pin); //Medida directa
    voltaje = voltaje/2; //En unidades normalizadas
    distancia_inst = distancia_inst + voltaje*2.54; //En cm
 }

 //Hacemos la media y lo mostramos
 float distancia = distancia_inst/num_medidas;
 return distancia;
} 


